<?php // phpcs:ignore WordPress.NamingConventions

/**
 * Notes class
 *
 * @author  YITH <plugins@yithemes.com>
 * @package YITH Desktop Notifications for WooCommerce
 * @version 1.0.0
 *
 * @class   YITH_WCDN_Desktop_Notifications_Ajax
 * @package YITH\YITH_Desktop_Notifications_Premium\Classes
 */

if ( ! defined( 'YITH_WCDN_VERSION' ) ) {
	exit( 'Direct access forbidden.' );
}


if ( ! class_exists( 'YITH_WCDN_Desktop_Notifications_Cron' ) ) {
	/**
	 * YITH_WCDN_Desktop_Notifications_Cron
	 *
	 * @since 1.0.0
	 */
	class YITH_WCDN_Desktop_Notifications_Cron {

		/**
		 * Single instance of the class
		 *
		 * @var \YITH_WCDN_Desktop_Notifications_Cron
		 * @since 1.0.0
		 */
		private static $instance;

		/**
		 * Returns single instance of the class
		 *
		 * @return \YITH_WCDN_Desktop_Notifications_Cron
		 */
		public static function get_instance() {
			$self = __CLASS__ . ( class_exists( __CLASS__ . '_Premium' ) ? '_Premium' : '' );

			if ( is_null( $self::$instance ) ) {
				$self::$instance = new $self();
			}

			return $self::$instance;
		}

		/**
		 * __construct
		 *
		 * @return void
		 */
		public function __construct() {
			add_action( 'wp_loaded', array( $this, 'set_cron' ), 30 );
			add_action( 'yith_wcdn_delete_notifications', array( $this, 'delete_notifications' ) );
		}

		/**
		 * Set cron
		 *
		 * @return void
		 */
		public function set_cron() {
			if ( ! wp_next_scheduled( 'yith_wcdn_delete_notifications' ) ) {
				wp_schedule_event( time(), 'daily', 'yith_wcdn_delete_notifications' );
			}
		}

		/**
		 * Delete notifications
		 *
		 * @return void
		 */
		public function delete_notifications() {
			$notification_instance = YITH_Desktop_Notifications()->register_notifications;
			$notification_instance->delete_notifications();
		}
	}
}
