<?php // phpcs:ignore WordPress.NamingConventions

/**
 * Notes class
 *
 * @author  YITH <plugins@yithemes.com>
 * @version 1.0.0
 *
 * @class   YITH_WCDN_Desktop_Notifications_Notify
 * @package YITH\YITH_Desktop_Notifications_Premium\Classes
 */

if ( ! defined( 'ABSPATH' ) ) {
	exit;
}

if ( ! class_exists( 'YITH_WCDN_Desktop_Notifications_Notify' ) ) {
	/**
	 * YITH_WCDN_Desktop_Notifications_Notify
	 *
	 * @since 1.0.0
	 */
	class YITH_WCDN_Desktop_Notifications_Notify {

		/**
		 * Single instance of the class
		 *
		 * @var \YITH_WCDN_Desktop_Notifications_Notify
		 * @since 1.0.0
		 */
		protected static $instance;


		/**
		 * Returns single instance of the class
		 *
		 * @return \YITH_WCDN_Desktop_Notifications_Notify
		 * @since 1.0.0
		 */
		public static function get_instance() {
			$self = __CLASS__ . ( class_exists( __CLASS__ . '_Premium' ) ? '_Premium' : '' );

			if ( is_null( $self::$instance ) ) {
				$self::$instance = new $self();
			}

			return $self::$instance;
		}

		/**
		 * Constructor
		 *
		 * @since  1.0.0
		 */
		private function __construct() {
			add_action( 'admin_enqueue_scripts', array( $this, 'enqueue_styles_scripts' ), 11 );
			add_action( 'wp_enqueue_scripts', array( $this, 'enqueue_styles_scripts' ), 11 );
		}

		/**
		 * Enqueue scripts
		 *
		 * @return void
		 */
		public function enqueue_styles_scripts() {

			/** APPLY_FILTERS: yith_wcdn_load_script
			*
			* Filter the condition to enqueue and localize the scripts.
			*/
			if ( apply_filters( 'yith_wcdn_load_script', __return_true() ) && is_user_logged_in() ) {

				wp_enqueue_script( 'yith_wcdn_notify', YITH_WCDN_ASSETS_URL . 'js/wcdn-notify.js', array( 'jquery', 'jquery-ui-sortable' ), YITH_WCDN_VERSION, false );
				$array = array(
					'ajaxurl'       => admin_url( 'admin-ajax.php' ),
					'time_check'    => get_option( 'yith_wcdn_settings_check_new_notification' ) * 1000, // 60000 miliseconds = 1 min
					'looping_sound' => get_option( 'yith_wcdn_settings_looping_sound' ),
				);
				wp_localize_script( 'yith_wcdn_notify', 'yith_wcdn', $array );
			}
		}
	}

}
